package com.jiuqi.mde;

import java.util.ArrayList;
import java.util.Hashtable;

public final class MDEDatasetSet {
   private ArrayList datasets = new ArrayList();
   private Hashtable nameSearch = new Hashtable();

   public int size() {
      return this.datasets.size();
   }

   public MDEDataset get(int index) {
      return (MDEDataset)this.datasets.get(index);
   }

   public MDEDataset find(String name) {
      return (MDEDataset)this.nameSearch.get(name);
   }

   public void add(MDEDataset dataset) {
      if (!this.nameSearch.containsKey(dataset.getName())) {
         this.datasets.add(dataset);
         this.nameSearch.put(dataset.getName(), dataset);
      }

   }

   public void add(int index, MDEDataset dataset) {
      if (!this.nameSearch.containsKey(dataset.getName())) {
         this.datasets.add(index, dataset);
         this.nameSearch.put(dataset.getName(), dataset);
      }

   }

   public void add(MDEDatasetSet datasets) {
      for(int i = 0; i < datasets.size(); ++i) {
         this.add(datasets.get(i));
      }

   }

   public void remove(int index) {
      MDEDataset dataset = (MDEDataset)this.datasets.get(index);
      this.nameSearch.remove(dataset.getName());
      this.datasets.remove(index);
   }

   public void remove(MDEDataset dataset) {
      this.datasets.remove(dataset);
      this.nameSearch.remove(dataset.getName());
   }

   public int indexOf(MDEDataset dataset) {
      for(int i = 0; i < this.datasets.size(); ++i) {
         MDEDataset dim = (MDEDataset)this.datasets.get(i);
         if (dim == dataset || dim.getName().equals(dataset.getName())) {
            return i;
         }
      }

      return -1;
   }

   public Object clone() {
      MDEDatasetSet result = new MDEDatasetSet();
      result.add(this);
      return result;
   }

   public void sortByName() {
      for(int i = 1; i < this.datasets.size(); ++i) {
         MDEDataset dataset = (MDEDataset)this.datasets.get(i);
         int start = 0;
         int stop = i - 1;
         int flag = true;

         int k;
         while(start <= stop) {
            k = start + stop >> 1;
            int flag = dataset.getName().compareTo(((MDEDataset)this.datasets.get(k)).getName());
            if (flag > 0) {
               start = k + 1;
            } else {
               if (flag >= 0) {
                  start = k;
                  break;
               }

               stop = k - 1;
            }
         }

         if (start < i) {
            for(k = i; k > start; --k) {
               this.datasets.set(k, this.datasets.get(k - 1));
            }

            this.datasets.set(start, dataset);
         }
      }

   }
}
